import os
import re
import datetime
import sys
from openpyxl import *
from Exos.parse import *
from Exos.getrawdata import *

def get_switch_info(file):
    sw=list
    switch=list()
    f=open(file, 'r')
    if f:
        s=f.read()
    else:
        print('File %s not found' %(file))
    f.close()
    if s:
        sw=s.split('\n')
        for i in sw:
            i=' '.join(i.split())
            if i !='':
                tmp=i.split(' ')
                switch.append(tmp)
    return switch

def gensimplerep(switch, anchor):
    wb=load_workbook('report.xlsx')
    ws=wb['extreme_simple_report']
    ws['D'+str(anchor)]=switch['model']
    ws['G'+str(anchor)]=switch['hostname']
    ws['L'+str(anchor)]=switch['ip']
    ws['Q'+str(anchor)]=switch['cpu util']
    ws['T'+str(anchor)]=switch['mem util']
    ws['V'+str(anchor)]=switch['temperature']
    ws['Z'+str(anchor)]=switch['power']
    ws['AB'+str(anchor)]=switch['fan']
    wb.save('report.xlsx')
    wb.close()

def repmain():
    now='Report Date: '+ str(datetime.datetime.now())
    wb=load_workbook('report.xlsx')
    ws=wb['extreme_simple_report']
    ws['A2']=now
    wb.save('report.xlsx')
    wb.close()
    anchor=4                           # initial position.
    sw=get_switch_info('switch.txt')
    for i in sw:
        print(anchor-3)
        protocol=i[4]
        data=ExosGetRawData(i)
        if protocol=='ssh':
            raw=data.get_ssh()
        elif protocol=='telnet':
            raw=data.get_telnet()
        else:
            print('Not supported!!!\n')
        del data
        switch=ExosParse(raw)
        gensimplerep(switch.saveresult(), anchor)
        anchor+=1
        del switch


if __name__=='__main__':
    print('+-------------------------------------------------------------+')
    print('| Extreme Switch switch simple maintenance tool...            |')
    print('| version 0.0.1                                               |')
    print('| Scripted by snowffox, Nov. 2018                             |')
    print('+-------------------------------------------------------------+')
    repmain()
    print('Done!!!')
